#!/usr/bin/env python
# this scrpit is used to comput the pssm and asa,ss
#2010-05-09
#input the fasta file
import os
import sys

if len(sys.argv)<2:
	print("Usage: BEST_my_realspine_20mer.py   fastaFile")
	sys.exit()

fr_n=sys.argv[1]
# read in the fasta file and split the each sequence into each file
fr=open(fr_n,'r')
lines=[line.strip() for line in fr.readlines()]
fr.close()


#make a folder 
fragment_folder_name="BEST_eachseq_20mer"
if not os.path.exists(fragment_folder_name):
	os.system("mkdir %s " %fragment_folder_name)
#store the protein fragment ids proteinID_1, proteinID_2,...
ids=[]

for i in range (len(lines)):
	if len(lines[i])>0 and lines[i][0]=='>':
		proid=lines[i][1:]
		proseq=lines[i+1]
		#fw1.write("%s\n" %proid) #write ids
		tmp=1
		for j in range(len(proseq)-19):
			tmp_id=proid+"_"+str(tmp)
			tmp+=1
			ids.append(tmp_id)
			fn="./"+fragment_folder_name+"/"+tmp_id
			fnr=open(fn,'w')
			fnr.write(">%s\n%s\n" %(tmp_id,proseq[j:(j+20)]))
			fnr.close()


#u"""
# sorted SS: secondary structure; ASA solvent accessible; PSSM
SS_folder="SS"
if not os.path.exists(SS_folder):
	os.system("mkdir %s" %SS_folder)
ASA_folder="ASA"
if not os.path.exists(ASA_folder):
	os.system("mkdir %s" %ASA_folder)
PSSM_folder="PSSM"
if not os.path.exists(PSSM_folder):
	os.system("mkdir %s" %PSSM_folder)

#Run the RealSpine3.0 "
for i in range(len(ids)):
	#f_name="./2010-08-08/"+ids[i]
	f_name="./"+fragment_folder_name+"/"+ids[i]
	cmd_line1="./BEST_rs3 %s " %f_name
	#f_name=ids[i]
	os.system(cmd_line1)
	print( "%d is done" %(i+1))
	os.system("rm -r temp*")

